/*
===============================================================================

	FILE:	arithmeticdecoder.h
	
	CONTENTS:
			
    An arithmetic coder that was adapted from the code provided by
    Frederic Wheeler. This coder is not particularly fast.

  PROGRAMMERS:
	
		martin isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		(c) 2001 martin isenburg@cs.unc.edu
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
		11 September 2001 -- created. adapted from frederic wheelers code.
	
===============================================================================
*/
#ifndef ARITHMETICDECODER_H
#define ARITHMETICDECODER_H

class ArithmeticModel;

class ArithmeticDecoder
{
public:

	ArithmeticDecoder(int* bits, int number_bits);
	~ArithmeticDecoder();

	int decode(ArithmeticModel* am);
	int decode(ArithmeticModel* am, int low_sym);
	int decode(int range);

	bool hasBits();

	int current_bit;

private:
	void decode();
	int input_bit();

	int* bits;
	int number_bits;
	int garbage_bits;
	__int64 value;
	__int64 low;
	__int64 high;
};

#endif
