/*
===============================================================================

	FILE:	arithmeticencoder.h
	
	CONTENTS:

    An arithmetic coder that was adapted from the code provided by
    Frederic Wheeler. This coder is not particularly fast.
			
	PROGRAMMERS:
	
		martin isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		(c) 2001 martin isenburg@cs.unc.edu
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
		11 September 2001 -- created. adapted from frederic wheelers code.
	
===============================================================================
*/
#ifndef ARITHMETICENCODER_H
#define ARITHMETICENCODER_H

class ArithmeticModel;

class ArithmeticEncoder
{
public:

	ArithmeticEncoder();
	~ArithmeticEncoder();

	void encode(ArithmeticModel* am, int sym);
	void encode(ArithmeticModel* am, int sym, int low_sym);
	void encode(int range, int sym);
	void done();

	int* getBits();
	int getNumberBits();

private:
	void encode();
	void output_bit(int bit);
	void bit_plus_follow(int bit);

	int* bits;
	int number_bits;
	int allocated_bits;

	__int64 low;
	__int64 high;
	__int64 fbits;
};

#endif
