/*
===============================================================================

	FILE:	arithmeticmodel.cpp
	
	CONTENTS:
			
    see corresponding header file

  PROGRAMMERS:
	
		martin isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		(c) 2001 martin isenburg@cs.unc.edu
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
    see corresponding header file
	
===============================================================================
*/
#include "arithmeticmodel.h"

ArithmeticModel::ArithmeticModel(int nsym, int adaptive, int* table)
{
	int i;
	
	this->nsym = nsym;
	this->adaptive = adaptive;
	this->freq = new int[nsym];
	this->cfreq = new int[nsym+1];
	
	cfreq[nsym] = 0;
	for (i = nsym-1; i>=0; i--)
	{
		if (table)
		{
			freq[i] = table[i];
			cfreq[i] = cfreq[i+1] + freq[i];
		}
		else
		{
			freq[i] = 1;
			cfreq[i] = nsym-i;
		}
	}
}

ArithmeticModel::~ArithmeticModel()
{
	delete [] freq;
	delete [] cfreq;
}

void ArithmeticModel::update(int sym)
{
	if (adaptive)
	{
		int i;
		if (cfreq[0] == 16383) // Max_frequency
		{
	    int cum = 0;
	    cfreq[nsym] = 0;
	    for (i = nsym-1; i>=0; i--)
			{
				freq[i] = (freq[i] + 1) / 2;
				cum += freq[i];
				cfreq[i] = cum;
	    }
	  }
		freq[sym] += 1;
	  for (i = sym; i >= 0; i--)
		{
	    	cfreq[i] += 1;
		}
	}
}
