/*
===============================================================================

	FILE:	loader.h
	
	CONTENTS:
	
    Thic code can read Tet meshes, Hex meshes, Curve Linear Grids, and also
    general Polyhedral meshes from an ASCII file and reconstruct connectivity
    to represent the mesh with a SpinEdge structure.
	
	PROGRAMMERS:
	
		martin isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		(c) 2002 martin isenburg@cs.unc.edu
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
		20 Feb 2002 -- created
	
===============================================================================
*/
#ifndef CF_LOADER_H
#define CF_LOADER_H

class CFmesh;

class CFloader
{
public:
  int loadMtl(char*, CFmesh*);
  int loadTet(char*, CFmesh*);
  int loadHex(char*, CFmesh*);
  int loadClg(char*, CFmesh*);
  int loadPol(char*, CFmesh*);
  
  CFloader();
  ~CFloader();
};

#endif
